//
//  ClassifierSVM.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 03.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "ClassifierLibSVM.h"
#include "utils.h"

ClassifierLibSVM::ClassifierLibSVM(svm_model *_model) {
    model = _model;
}

int ClassifierLibSVM::classify(cv::Mat im) {
    
    if (im.type() != CV_64F) {
        im.convertTo(im, CV_64F);
    }
    
    struct svm_node *svmVec;
    svmVec = (struct svm_node *)malloc((im.rows*im.cols+1)*sizeof(struct svm_node));
    
    int cnt = 0;
    for (int i=0; i<im.rows; i++) {
        for (int j=0; j<im.cols; j++) {
            svmVec[cnt].index = cnt+1;
            svmVec[cnt].value = im.at<double>(j,i);
            cnt++;
        }
    }
    svmVec[cnt].index = -1;
    
    double y = svm_predict(this->model, svmVec);
    return (int) y;
}

int ClassifierLibSVM::load(const char* filename) {
    model = svm_load_model(filename);
    return 0;
}
