//
//  ClassifierSVM.cpp
//  MANITEST
//
//  Created by Alhussein Fawzi on 03.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#include "ClassifierSVM.h"

ClassifierSVM::ClassifierSVM(cv::Ptr<cv::ml::SVM> _svm) {
    svm = _svm;
}

int ClassifierSVM::classify(cv::Mat im) {
    std::cout << "Reached ClassifierSVM->classify\n";
    cv::Mat im2;
    im.reshape(0,1).copyTo(im2);
    if (im2.type() != CV_32F) {
        im2.convertTo(im2, CV_32F);
    }
    /* cout << "rows = " << im2.rows << endl;
    cout << "cols = " << im2.cols << endl;
    cout << "type = " << im2.type() << endl;
    */
    return (int) svm->predict(im2); // reshape to a row vector and classify
    // return 0;
}

int ClassifierSVM::load(std::string filename) {
    /*FileStorage fs( filename, FileStorage::READ);
    (*svm).read(fs.getFirstTopLevelNode());
    return 0; */
    
    svm = cv::Algorithm::load<cv::ml::SVM>(filename);
    return 0;
    // TODO: Check whether the file has been correctly opened.
}

void ClassifierSVM::printInfo() {
    std::cout << "SVM with kernel type  = " << svm->getKernelType() << std::endl;
    std::cout << "                   C  = " << svm->getC() << std::endl;
    std::cout << "               gamma  = " << svm->getGamma() << std::endl;
    std::cout << "               degree = " << svm->getDegree() << std::endl;
    std::cout << "               coef0  = " << svm->getCoef0() << std::endl;
    std::cout << "                   p  = " << svm->getP() << std::endl;
    std::cout << "                type  = " << svm->getType() << std::endl;
}