//
//  Classifiers.h
//  MANITEST
//
//  Created by Alhussein Fawzi on 03.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#ifndef __MANITEST__Classifiers__
#define __MANITEST__Classifiers__

#include <stdio.h>
#include <iostream>
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/highgui/highgui.hpp"
#include <opencv2/ml/ml.hpp>
#include "SingleClassifier.h"

#endif /* defined(__MANITEST__Classifiers__) */


#ifndef CLASSIFIERS_H
#define CLASSIFIERS_H

class Classifiers{
public:

    // Constructors

    Classifiers(); // Create empty list of classifiers
    Classifiers(std::vector<SingleClassifier*> *v);  // Create list from vector of classifiers
    
    // Methods
    
    // Import from file methods
    // int importSVM(string filename); // Return id
    // int importCaffe(string filename); // Return id
    
    // Classify methods
    // Other ways of importing (?)
    
    // Utility functions
    void addClassifier(SingleClassifier *c);
    void printClassifiers();
    void removeClassifier(int classifierID);
    
    // Classification function (used by Manitest)
    std::vector<int> classify(cv::Mat img, std::vector<bool> mask);
    std::vector<int> classify(cv::Mat img);

    int numClassifiers() {return ListClassifiers.size();};
    
    // ListClassifiers contains the pointers to the different classifiers
    std::vector<SingleClassifier*> ListClassifiers;
};

#endif

    /*
    // Define of classifiers
    struct Clist {
        string type;
        bool toClassify;
        int id;
        T model;
        // int model;
    };
    
    vector<Clist> a;
    
    struct subject
    {
        string name;
        int marks;
        int credits;
    };
    vector<subject> sub;
    boost::variant<Clist, std::string > u;
    typedef int MyInt;
};

template<typename T>
class abc{
    T hello;
    int x;
};

vector<abc<double>> a;*/