//
//  Manitest.h
//  MANITEST
//
//  Created by Alhussein Fawzi on 20.05.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#ifndef __MANITEST__Manitest__
#define __MANITEST__Manitest__

#include <stdio.h>
#include <iostream>
#include <map>
#include <deque>
#include <assert.h>
#include "utils.h"
#include "Transformation.h"
#include "Classifiers.h"

#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/highgui/highgui.hpp"
#include <opencv2/ml/ml.hpp>

class Stencil;

class Manitest {

public:
        
    // Constructors
    Manitest(cv::Mat _img, Transformation *_trans, Stencil *_stencil, Classifiers *_classifiers);
    
    void initialize();
    void run();
    std::vector<int> initializeReversedStencil(std::vector<point>* rStencil);
    std::vector<double> coords2Para(std::vector<int> *coords);
    cv::Mat constructDistanceMap();
    bool checkOutOfBounds(std::vector<int> *c);
    int p;
    char *mode;
    
    // Variables
    // The coords->id is necessary for efficiently checking whether the newly created coordinate exists already
    std::map<std::vector<int>, int> coords2Id;
    std::deque<std::vector<int> > id2Coords;
    std::deque<double> dist; // TODO: Make it a hash table.
    std::deque<bool> visited;
    std::deque<cv::Mat> metrics;
    
    int N;
    
    Stencil *stencil;
    Transformation *trans;
    Classifiers *classifiers = nullptr;
    
    std::vector<int> labelsOrig;
    std::vector<double> scores;
    std::vector<std::vector<double> > params;
    std::vector<cv::Mat> images;
    cv::Mat img;
    cv::Mat getImg() { return img; }
};

#endif /* defined(__MANITEST__Manitest__) */

