//
//  Stencil.h
//  MANITEST
//
//  Created by Alhussein Fawzi on 15.06.15.
//  Copyright (c) 2015 Alhussein Fawzi. All rights reserved.
//

#ifndef __MANITEST__Stencil__
#define __MANITEST__Stencil__

#include <stdio.h>
#include <iostream>
#include <vector>
#include <assert.h>
#include <deque>
#include <map>
#include <fstream>
#include "Manitest.h"

#include "opencv2/imgproc/imgproc.hpp"


class Stencil {
public:
    // Constructors
    Stencil();
    
    virtual std::vector<int> getReversedStencilsId(point* coord) {return std::vector<int>(0); };
    int initializeNode(point node);
    cv::Mat computeMetric(std::vector <double> para);
    
    bool checkOutOfBounds(point coord);
    
    std::vector<simplex> simplexSet;
    std::vector<std::vector<int> > simplexSetId; // Id of the simplex set
    
    virtual void genSimplicesRecId(point* coord, point *y, int y_dim, std::vector<int> cur_simplex, int cur_dim) {};
    virtual void genSimplicesId(point* coord, point* y) {};
    
    std::vector<double> minPoint; std::vector<double> maxPoint;
    std::vector<double> hs;
    std::vector<double> offsets;
    std::vector<double> coords2Para(std::vector<int>* coords);
    
    Manitest* parentClass;
};

#endif